<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2002 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'User listing' for the 'newloginbox' extension.
 *
 * @author    Kasper Skrhj <kasper@typo3.com>
 */


require_once(PATH_tslib."class.tslib_pibase.php");

class tx_newloginbox_pi3 extends tslib_pibase {
    var $prefixId = "tx_newloginbox_pi3";        // Same as class name
    var $scriptRelPath = "pi3/class.tx_newloginbox_pi3.php";    // Path to this script relative to the extension dir.
    var $extKey = "newloginbox";    // The extension key.
    
    /**
     * Main function
     */
    function main($content,$conf)    {
        switch((string)$conf["CMD"])    {
            case "singleView":
                list($t) = explode(":",$this->cObj->currentRecord);
                $this->internal["currentTable"]=$t;
                $this->internal["currentRow"]=$this->cObj->data;
                return $this->pi_wrapInBaseClass($this->singleView($content,$conf));
            break;
            default:
                if (strstr($this->cObj->currentRecord,"tt_content"))    {
                    $conf["pidList"] = $this->cObj->data["pages"];
                    $conf["recursive"] = $this->cObj->data["recursive"];
                }
                return $this->pi_wrapInBaseClass($this->listView($content,$conf));
            break;
        }
    }
    
    /**
     * List view
     */
    function listView($content,$conf)    {
        $this->conf=$conf;        // Setting the TypoScript passed to this function in $this->conf
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();        // Loading the LOCAL_LANG values
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
        $this->lConf = $lConf = $this->conf["listView."];    // Local settings for the listView function
		$this->pi_alwaysPrev = $this->lConf["alwaysPrev"];
        
        if ($this->piVars["showUid"])    {    // If a single element should be displayed:
            $this->internal["currentTable"] = "fe_users";
            $this->internal["currentRow"] = $this->pi_getRecord("fe_users",$this->piVars["showUid"]);
            
            $content = $this->singleView($content,$conf);
            return $content;
        } else {
/*            $items=array(
                "1"=> $this->pi_getLL("list_mode_1","Mode 1"),
                "2"=> $this->pi_getLL("list_mode_2","Mode 2"),
                "3"=> $this->pi_getLL("list_mode_3","Mode 3"),
            );
*/
            if (!isset($this->piVars["pointer"]))    $this->piVars["pointer"]=0;
//            if (!isset($this->piVars["mode"]))    $this->piVars["mode"]=1;
    
                // Initializing the query parameters:
            list($this->internal["orderBy"],$this->internal["descFlag"]) = explode(":",$this->piVars["sort"]);
            $this->internal["results_at_a_time"]=t3lib_div::intInRange($lConf["results_at_a_time"],0,1000,3);        // Number of results to show in a listing.
            $this->internal["maxPages"]=t3lib_div::intInRange($lConf["maxPages"],0,1000,2);;        // The maximum number of "pages" in the browse-box: "Page 1", "Page 2", etc.
            $this->internal["searchFieldList"]="username,name,email,country,city,zip,telephone,address,title";
            $this->internal["orderByList"]="username,name,email,country,city,zip";
            
                // Get number of records:
            $query = $this->pi_list_query("fe_users",1);
            $res = mysql(TYPO3_db,$query);
            if (mysql_error())    debug(array(mysql_error(),$query));
            list($this->internal["res_count"]) = mysql_fetch_row($res);
    
                // Make listing query, pass query to MySQL:
            $query = $this->pi_list_query("fe_users");
            $res = mysql(TYPO3_db,$query);
            if (mysql_error())    debug(array(mysql_error(),$query));
            $this->internal["currentTable"] = "fe_users";
    
                // Put the whole list together:
            $fullTable="";    // Clear var;
        #    $fullTable.=t3lib_div::view_array($this->piVars);    // DEBUG: Output the content of $this->piVars for debug purposes. REMEMBER to comment out the IP-lock in the debug() function in t3lib/config_default.php if nothing happens when you un-comment this line!
                
                // Adds the mode selector.
#            $fullTable.=$this->pi_list_modeSelector($items);    
            
                // Adds the search box:
            $fullTable.=$this->pi_list_searchBox();
                
                // Adds the result browser:
            $fullTable.=$this->pi_list_browseresults();
            
                // Adds the whole list table
            $fullTable.=$this->pi_list_makelist($res);
            
                // Returns the content from the plugin.
            return $fullTable;
        }
    }

    /**
     * Single view display
     */
    function singleView($content,$conf)    {
        $this->conf=$conf;
        $this->pi_setPiVarDefaults();
        $this->pi_loadLL();
    
            // This sets the title of the page for use in indexed search results:
        if ($this->internal["currentRow"]["title"])    $GLOBALS["TSFE"]->indexedDocTitle=$this->internal["currentRow"]["title"];
    
		if ($GLOBALS["TSFE"]->loginUser)	{
				$image="";
				if ($this->internal["currentRow"]["tx_extrepmgm_images"])	{
					$imgArr = t3lib_div::trimExplode(",",$this->internal["currentRow"]["tx_extrepmgm_images"],1);
					$GLOBALS["TSFE"]->make_seed();
					$randval = intval(rand(0,count($imgArr)-1));
					$imgFile = "uploads/tx_extrepmgm/".$imgArr[$randval];
					$imgInfo = getimagesize(PATH_site.$imgFile);
					if (is_array($imgInfo))	{
						$image='<img src="'.$imgFile.'" '.$imgInfo[3].'>';
					}
				}
	
	        	$theTable = '
	            <table '.$this->conf["tableParams_details"].'>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("username").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("username").'</P></td>
						<td valign="top" rowspan="20">'.$image.'</td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("name").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("name").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("title").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("title").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("email").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("email").'</P></td>
	                </tr>
					
	                <tr>
	                    <td colspan=2><img src="clear.gif" width=1 height=2></td>
	                </tr>
	
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("address").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("address").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("city").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("zip").'-'.$this->getFieldContent("city").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("country").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("country").'</P></td>
	                </tr>
					
	                <tr>
	                    <td colspan=2><img src="clear.gif" width=1 height=2></td>
	                </tr>
	
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("telephone").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("telephone").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("fax").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("fax").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("company").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("company").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("homepage").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("www").'</P></td>
	                </tr>
					
	                <tr>
	                    <td colspan=2><img src="clear.gif" width=1 height=2></td>
	                </tr>
	
	                <tr>
	                    <td valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("contribute").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("tx_extrepmgm_contribute").'</P></td>
	                </tr>
	                <tr>
	                    <td valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("personallife").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("tx_extrepmgm_personallife").'</P></td>
	                </tr>
	                <tr>
	                    <td valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("typo3experiences").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("tx_extrepmgm_typo3experiences").'</P></td>
	                </tr>
					
	                <tr>
	                    <td colspan=2><img src="clear.gif" width=1 height=2></td>
	                </tr>
	
	                <tr>
	                    <td nowrap'.$this->pi_classParam("singleView-HCell").'><P>Created:</P></td>
	                    <td valign="top"><P>'.date("d-m-Y H:i",$this->internal["currentRow"]["crdate"]).'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap'.$this->pi_classParam("singleView-HCell").'><P>Last login:</P></td>
	                    <td valign="top"><P>'.date("d-m-Y H:i",$this->internal["currentRow"]["lastlogin"]).'</P></td>
	                </tr>
	            </table>
			';

			$content='<DIV'.$this->pi_classParam("singleView").'>
	            <H3>Details about '.$this->internal["currentRow"]["name"].' ('.$this->internal["currentRow"]["username"].'):</H3>
				'.$theTable;			
		} else {
	        $content='<DIV'.$this->pi_classParam("singleView").'>
	            <H3>Limited details about '.$this->internal["currentRow"]["name"].' ('.$this->internal["currentRow"]["username"].'):</H3>
	            <table '.$this->conf["tableParams_details"].'>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("username").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("username").'</P></td>
	                </tr>
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("name").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("name").'</P></td>
	                </tr>
					'.($this->conf['listView.']["show."]["email_in_details"]?'
	                <tr>
	                    <td nowrap valign="top"'.$this->pi_classParam("singleView-HCell").'><P>'.$this->getFieldHeader("email").'</P></td>
	                    <td valign="top"><P>'.$this->getFieldContent("email").'</P></td>
	                </tr>':'').'
	            </table>
			';
		}
		
		
		if ($this->piVars["returnUrl"])	{
			$content.='<P><a href="'.$this->piVars["returnUrl"].'">Back</a></P>';
		} else {
			$content.='<P>'.$this->pi_list_linkSingle("Back",0).'</P>';
		}
		
		$content.='</DIV>'.
        $this->pi_getEditPanel();
    
        return $content;
    }

    /**
     * A single list row displayed:
     */
    function pi_list_row($c)    {
        $editPanel = $this->pi_getEditPanel();
        if ($editPanel)    $editPanel="<TD>".$editPanel."</TD>";
        
		if ($GLOBALS["TSFE"]->loginUser)	{
	        return '<tr'.($c%2 ? $this->pi_classParam("listrow-odd") : "").'>
	                <td valign="top"><P>'.$this->getFieldContent("name").'</P></td>
	                <td valign="top"><P>'.$this->getFieldContent("city").'</P></td>
	                <td valign="top"><P>'.$this->getFieldContent("country").'</P></td>
	                '.($this->lConf["show."]["email"] ? '<td valign="top"><P>'.$this->getFieldContent("email").'</P></td>' :'').'
	                <td valign="top"><P>'.$this->getFieldContent("username").'</P></td>
	                '.$editPanel.'
	            </tr>';
		} else {
	        return '<tr'.($c%2 ? $this->pi_classParam("listrow-odd") : "").'>
	                <td valign="top"><P>'.$this->getFieldContent("name").'</P></td>
	                <td valign="top"><P>'.$this->getFieldContent("username").'</P></td>
	                '.$editPanel.'
	            </tr>';
		}
    }

    /**
     * List header row:
     */
    function pi_list_header()    {
		if ($GLOBALS["TSFE"]->loginUser)	{
	        return '<tr'.$this->pi_classParam("listrow-header").'>
	                <td><P>'.$this->getFieldHeader_sortLink("name").'</P></td>
	                <td><P>'.$this->getFieldHeader_sortLink("city").'</P></td>
	                <td><P>'.$this->getFieldHeader_sortLink("country").'</P></td>
	                '.($this->lConf["show."]["email"] ? '<td><P>'.$this->getFieldHeader_sortLink("email").'</P></td>' :'').'
	                <td><P>'.$this->getFieldHeader_sortLink("username").'</P></td>
	            </tr>';
		} else {
	        return '<tr'.$this->pi_classParam("listrow-header").'>
	                <td><P>'.$this->getFieldHeader_sortLink("name").'</P></td>
	                <td><P>'.$this->getFieldHeader_sortLink("username").'</P></td>
	            </tr>';
		}
    }

    /**
     * Field content
     */
    function getFieldContent($fN)    {
        switch($fN) {
            case "name":
            case "username":
                return $this->pi_list_linkSingle($this->internal["currentRow"][$fN],$this->internal["currentRow"]["uid"],1);
            break;
            case "email":
                return $this->cObj->gettypolink($this->internal["currentRow"]["email"],$this->internal["currentRow"]["email"]);
            break;
            default:
                return $this->internal["currentRow"][$fN];
            break;
        }
    }

    /**
     * Field header name
     */
    function getFieldHeader($fN)    {
        switch($fN) {
            default:
                return $this->pi_getLL("listFieldHeader_".$fN,"[".$fN."]");
            break;
        }
    }
    
    /**
     * Sort-by-row link
     */
    function getFieldHeader_sortLink($fN)    {
        return $this->pi_linkTP_keepPIvars($this->getFieldHeader($fN),array("sort"=>$fN.":".($this->internal["descFlag"]?0:1)));
    }
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/newloginbox/pi3/class.tx_newloginbox_pi3.php"])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/newloginbox/pi3/class.tx_newloginbox_pi3.php"]);
}

?>